#include <stdio.h>
#include "utils/utils.h"

#include "conf/conf.h"
#include "module/module_api.h"



int type_auth_client(char *client, char *password) {
	debug("type_auth_client [libkatrin-auth-db.c]");

	kcfg *cfg = get_katrin_cfg();
	debug("Load db lib");
	add_module(DB, cfg->db_mod);
	free_katrin_cfg(cfg);

	if (db.db_api.checkloginpassword(client, password) == 1) {
		debug("return 1 from libkatrin-auth-db.c");
		return 1;
	}

	return 0;
}


char *type_get_client_password(char *login) {
	notice("type_get_client_password [libkatrin-auth-db.c]");
	char *password = NULL;

	kcfg *cfg = get_katrin_cfg();
	debug("Load db lib");
	add_module(DB, cfg->db_mod);
	free_katrin_cfg(cfg);

	struct client *client = db.db_api.get_client(0, login, NULL, NULL, NULL);
	if (client == NULL) {
		debug("not found client with %s login", login);
		return NULL;
	}

	if (asprintf(&password, "%s", client->password) == -1) {
		warn("Can't allocate memory for password");
		free_client(client);
		return NULL;
	}

	free_client(client);
	return password;
}
