#include "utils/utils.h"

#include "conf/conf.h"
#include "module/module_api.h"
#include "external.h"


int type_auth_client(char *client, char *password) {
	notice("type_auth_client [libkatrin-auth-external.c]");
	char *from_stdout = NULL;
	int rez = 0;

	kcfg *cfg = get_katrin_cfg();
	notice("Exec external prog: %s", cfg->external_auth);

	char *to_stdin = NULL;
	if (asprintf(&to_stdin, "%s %s\n", client, password) == -1) {
		warn("Can't allocate memory for to_stdin");
		free_katrin_cfg(cfg);
		return 0;
	}

	from_stdout = run_external_program(cfg->external_auth, to_stdin);

	if (from_stdout != NULL && strcmp(from_stdout, "OK\n") == 0)
		rez = 1;

	free_katrin_cfg(cfg);
	free(to_stdin);
	free(from_stdout);

	return rez;
}

char *type_get_client_password(char *login) {
	notice("type_get_client_password [libkatrin-auth-external.c]");
	char *from_stdout = NULL;
	char *password = NULL;

	kcfg *cfg = get_katrin_cfg();
	notice("Exec external prog: %s", cfg->external_auth);

	char *to_stdin = NULL;
	if (asprintf(&to_stdin, "%s GETPASSWD\n", login) == -1) {
		warn("Can't allocate memory for to_stdin");
		free_katrin_cfg(cfg);
		return NULL;
	}

	char *cmd_line = NULL;
	if (asprintf(&cmd_line, "%s --get-password", cfg->external_auth) == -1) {
		warn("Can't allocate memory for cmd_line");
		free_katrin_cfg(cfg);
		free(to_stdin);
		return NULL;
	}

	from_stdout = run_external_program(cmd_line, to_stdin);

	free(cmd_line);
	free_katrin_cfg(cfg);
	free(to_stdin);

	return from_stdout;
}
