#include "bz/bz.h"
#include "tel.h"
#include "stat/libkatrin-stat-tel.h"

struct client_tel_info *service2clientService(struct tel_info *tel) {
	debug("service2clientService in bz-tel module");
	struct client_tel_info *pUTI = (struct client_tel_info *) malloc(sizeof(struct client_tel_info));
	pUTI->tel = (*tel);
	//	Get info
	int tariffid = 0;
	int accountid = 0;

	struct client *client = db.db_api.get_client(0, NULL, "tel", "tel_number", tel->dst_number);
	if (client == NULL) {
		client = db.db_api.get_client(0, NULL, "tel", "tel_number",  tel->src_number);
		if (client != NULL) {
			pUTI->in_call = OUTPUT_CALL;
		}
	}
	else {
		pUTI->in_call = INPUT_CALL;
	}

	if (client != NULL ) {
		struct serviceslist *sl = db.db_api.get_client_services(client->id, Personal, "tel");
		tariffid = sl->tariff.id;
		accountid = sl->account.id;
		free(sl);
		pUTI->client_id = client->id;
		pUTI->account_id = accountid;
		free_client(client);
	}
	else {
		debug("client is NULL, creating stub pUTI...");
		pUTI->client_id = 0;
		pUTI->account_id = 0;
		pUTI->filterid = 0;
		pUTI->cost = 0;
		return pUTI;
	}

	//	Apply filters
	int usefilter = 0;
	int applyfilter = 0;
	int store_service_stat = 0;

	struct filterslist *filters = db.db_api.tariffid2filters(tariffid, "tel");
	struct filterslist *pfl = NULL;

	if (filters == NULL) {
		pUTI->cost = 0;
		return pUTI;
	}

	for (; filters!=NULL; filters=pfl ) {
		if (applyfilter == 1)

		usefilter = 0;

		char *src_number = get_param_value("src_number", filters->filter.params);
		char *dst_number = get_param_value("dst_number", filters->filter.params);
		char *src_trunk = get_param_value("src_trunk", filters->filter.params);
		char *dst_trunk = get_param_value("dst_trunk", filters->filter.params);
		int in_call = atoi(get_param_value("in_call", filters->filter.params));
		double persecond_in = atof(get_param_value("persecond_in", filters->filter.params));
		double persecond_out = atof(get_param_value("persecond_out", filters->filter.params));

		// Check direction
		if (in_call==0 || in_call==pUTI->in_call) {
			debug("Apply direction of call");
			if (strlen(src_number) == 0 || strcmp(src_number, tel->src_number)) {
				debug("Apply src number");
				if (strlen(dst_number) == 0 || strcmp(dst_number, tel->dst_number)) {
					debug("Apply dst number");
					if (strlen(src_trunk) == 0 || strcmp(src_trunk, tel->src_trunk)) {
						debug("Apply src trunk");
						if (strlen(dst_trunk) == 0 || strcmp(dst_trunk, tel->dst_trunk)) {
							debug("Apply dst trunk");
							debug("usefilter set to 1");
							usefilter=1;
							store_service_stat = filters->filter.store_stat;
						}
					}
				}
			}
		}

		//Apply cost from first cheched filter and exit from check filters ELSE check next filter/
		if (usefilter==1 && applyfilter==0) {
			if (pUTI->in_call == INPUT_CALL)
				pUTI->cost = ((double)tel->duration)*persecond_in;
			if (pUTI->in_call == OUTPUT_CALL)
				pUTI->cost = ((double)tel->duration)*persecond_out;
			pUTI->filterid = filters->filter.id;
			applyfilter = 1;
		}
next_and_free_filter:
		pfl = filters->next;
		free_paramlist(filters->filter.params);
		free(filters);
	}

	if (applyfilter == 0) {
		pUTI->cost = 0;
		pUTI->filterid = 0;
	}

	// Store stat before return rezult
	if (usefilter == 1 && store_service_stat == 1)
		store_stat(pUTI);

	debug("exit from service2clientService (tel bz module)");
	return pUTI;
}

int allow_auth(char *login) {
	return allow_auth_default(login, "tel");
}

