#ifndef _KATRIN_MODULE_H_
#define _KATRIN_MODULE_H_

#include "def.h"
#include "traff.h"

#define NAME_LENGTH 64

struct bz_interface {
	struct client_service_info* (*service2clientService)(struct service_info *si);
	int (*allow_auth)(char *login);

	int (*reload_conf)(void);
};

struct info_interface {
	int (*reload_conf)(void);
};

struct db_interface {
	void (*module_init)(void);
	void (*dbDisconnect)(void);
	int (*dbConnect)(void);
	void (*writeoffcost)(double cost,int account_id);
	void (*set_account_blocked)(int client_id, int value);
	int (*checkloginpassword)(const char* login, const char* password);
	struct abonentslist* (*update_account_state)(enum accountState blocked);
	struct clientslist* (*get_clientgroup_members)(int clientgroup_id); 
	void (*addstat)(char *typeService, int client_id, int filterid, double cost, struct paramlist *params);	
	struct filterslist* (*tariffid2filters)(int tariffid, char *typeService);
	struct clientslist* (*tariffid2clients)(int tariff_id);
	struct client *(*get_client)(int id, char *login, char *typeService, char *uparam, char *uvalue);
	struct tariff* (*get_tariff)(int id);
	struct account* (*get_account)(int id);
	struct serviceslist *(*get_client_clientgroups_services)(int client_id, char *serviceName);
	struct serviceslist *(*get_client_services)(int id, enum accountType type, char *serviceName);
	struct paramlist *(*get_client_params)(int client_id, char *typeService);
	struct paramlist *(*get_clientgroup_params)(int clientgroup_id, char *typeService);

	int (*reload_conf)(void);
};

struct bz_module {
	char name[NAME_LENGTH];
	struct bz_interface bz_api;

	void* handleLibBZ;
};

struct info_module {
	char name[NAME_LENGTH];
	struct info_interface info_api;

	pid_t pid;
};

struct db_module {
	char name[NAME_LENGTH];
	struct db_interface db_api;

	void* handleLibDB;
};

struct module_api{
	int (*add)(const char* type, const char* name, ...);
	int (*remove)(const char* type, const char* name);
	int (*contain)(const char* type, const char* name);
	int (*reload)(const char* type, const char* name);
	int (*reload_conf)(const char* type);
	int (*count)(const char* type);
};

typedef struct db_module db_module;
typedef struct bz_module bz_module;
typedef struct info_module info_module;
typedef struct module_api module_api; 

#endif


