#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "def.h"
#include "traff.h"
#include "conf/conf.h"
#include "utils/utils.h"

#include "module/module_api.h"



void store_stat(struct client_traff_info *uTraffic) {
	debug("store_stat");

	/* Get params from uTraffic */
	struct paramlist *spl = NULL;
	char addr[MAX_PARAM_VALUE_LENGTH];

	// Add addr
	if (uTraffic->in_traff==INPUT_TRAFF) 
		sprintf(addr, "%u", ntohl(uTraffic->traffic.src_addr.s_addr));
	else
		sprintf(addr, "%u", ntohl(uTraffic->traffic.dst_addr.s_addr));

	add_param(&spl, "addr", addr);

	// Add src port
	add_intparam(&spl, "src_port", uTraffic->traffic.src_port);

	// Add dst port
	add_intparam(&spl, "dst_port", uTraffic->traffic.dst_port);

	// Add bytes
	add_intparam(&spl, "bytes", (int)uTraffic->traffic.bytes);

	// Add proto
	add_intparam(&spl, "proto", (int)uTraffic->traffic.proto);

	// Add in_traff
	add_intparam(&spl, "in_traff", uTraffic->in_traff);

	/* Store info to db */
	db.db_api.addstat("traff", uTraffic->client_id, uTraffic->filterid, uTraffic->cost, spl);

	free_paramlist(spl);
}


