#include <stdio.h>
#include "utils/traff.h"


struct network_list *get_network_list(char *network_list_str) {
	struct network_list *network_list_result = NULL;
	struct network_list *network_list_first = NULL;
	struct network_list *network_list_last = NULL;

	char network[] = "255.255.255.255/24";
	int network_i = 0;
	char network_name[] = "255.255.255.255";
	int network_name_i = 0;
	char network_mask[] = "255.255.255.255";
	int network_mask_i = 0;
	int next_network_mask = 0;

	u_long n = 0;
	u_long y = 0;
	u_long full32 = 0xFFFFFFFF;
	struct in_addr addr;

	int i = 0;
	for (i=0; i<=strlen(network_list_str);i++) {
		if (network_list_str[i] == '\n' || network_list_str[i] == '\0') {
			network_mask[network_mask_i] = '\0';

			// Actions with network
			network_list_result = malloc(sizeof(struct network_list));
			if (NULL == network_list_first) {
				network_list_first = network_list_result;
			} else {
				network_list_last->next = network_list_result;
			}

			n = atoi(network_mask);
			y = full32 >> (32-n);
			y = y << (32-n);
			network_list_result->net.mask = y;
			network_list_result->net.name = htonl(inet_addr(network_name));
			network_list_result->next = NULL;
			
			// Save last
			network_list_last = network_list_result;

			network_i = 0;
			network[0] = "\0";

			network_name_i = 0;
			network_name[0] = "\0";

			network_mask_i = 0;
			network_mask[0] = "\0";

			next_network_mask = 0;

			continue;
		}

		if (network_list_str[i] == '/') {
			network_name[network_name_i] = '\0';
			next_network_mask = 1;
			continue;
		}

		if (1 == next_network_mask) {
			network_mask[network_mask_i] = network_list_str[i];
			network_mask_i++;
		} else {
			network_name[network_name_i] = network_list_str[i];
			network_name_i++;
		}
	}

	return network_list_first;
}

void free_network_list(struct network_list *nl) {
	struct network_list *item = NULL;
	struct network_list *p = nl;
	while (p != NULL) {
		item = p;
		p = p->next;
		free(item);
	}
}

int check_ip_in_list(u_long ip, struct network_list *nl) {
	struct network_list *p = nl;
	while (p != NULL) {
		if ((ip & p->net.mask) == p->net.name)
			return 1;
		p = p->next;
	}
	return 0;
}

